Bug 961405 - Review Request: mingw-openjpeg - MinGW Windows OpenJPEG library
Review Request: mingw-openjpeg - MinGW Windows OpenJPEG library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Thomas Sailer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-09 10:48 EDT by Sandro Mani
Modified: 2013-06-04 23:18 EDT (History)
5 users (show)

See Also:
Fixed In Version: mingw-openjpeg-1.5.1-3.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-06-04 17:03:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
t.sailer: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Sandro Mani 2013-05-09 10:48:24 EDT
Spec URL: http://smani.fedorapeople.org/mingw-openjpeg.spec
SRPM URL: http://smani.fedorapeople.org/mingw-openjpeg-1.5.1-1.fc20.src.rpm
Description: MinGW Windows OpenJPEG library
Fedora Account System Username: smani
Comment 1 Thomas Sailer 2013-05-09 18:12:37 EDT
Scratch Build http://koji.fedoraproject.org/koji/taskinfo?taskID=5359648
Comment 2 Thomas Sailer 2013-05-09 18:26:39 EDT
+ OK
! Needs to be looked into
/ Not applicable
* Overridden by MinGW guidelines

$ $ rpmlint *.rpm mingw-openjpeg.spec 
mingw32-openjpeg-debuginfo.noarch: E: debuginfo-without-sources
mingw32-openjpeg-tools.noarch: W: no-documentation
mingw64-openjpeg-debuginfo.noarch: E: debuginfo-without-sources
mingw64-openjpeg-tools.noarch: W: no-documentation
mingw-openjpeg.src: W: invalid-url Source0: http://openjpeg.googlecode.com/files/openjpeg-1.5.1.tar.gz HTTP Error 404: Not Found
mingw-openjpeg.spec: W: invalid-url Source0: http://openjpeg.googlecode.com/files/openjpeg-1.5.1.tar.gz HTTP Error 404: Not Found
7 packages and 1 specfiles checked; 2 errors, 4 warnings.

[+] The source URL warnings can be ignored; wget downloads the file from the given URL just fine. This seems to be a bug in rpmlint
[+] The other errors and warnings can be ignored as well

[+] Files are installed in /usr/i686-w64-mingw32/sys-root/mingw, /usr/x86_64-w64-mingw32/sys-root/mingw/
[+] BuildRequires: mingw32-filesystem, mingw64-filesystem is in the .spec file
[+] Requires are OK
[+] BuildArch: noarch
[+] No man pages or info files
[+] default strip and objdump commands are overridden with mingw specific ones

[+] rpmlint must be run on every package. The output should be posted in the review
[+] MUST: The package must be named according to the Package Naming Guidelines
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines
[+] MUST: The package must meet the Packaging Guidelines
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+] MUST: The License field in the package spec file must match the actual license
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
$ md5sum openjpeg-1.5.1.tar.gz o/openjpeg-1.5.1.tar.gz 
b5f74cec2688fb918331bb014061be6f  openjpeg-1.5.1.tar.gz
b5f74cec2688fb918331bb014061be6f  o/openjpeg-1.5.1.tar.gz
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines; inclusion of those as BuildRequires is optional.
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[*] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
[+] MUST: The package must contain code, or permissable content.
[/] MUST: Large documentation files should go in a -doc subpackage.
[/] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[*] MUST: Header files must be in a -devel package.
[+] MUST: Static libraries must be in a -static package.
[/] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[*] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[*] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[*] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[/] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[/] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[+] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[/] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

Some points:
- A dependency on pkgconfig, while not strictly required, might be useful
- Why aren't you building static libraries? I'm not particularly attached to those, but it seems to be customary for mingw packages to do so...
- The unversioned DLL seems a bit dangerous (i.e. libopenjpeg.dll instead of libopenjpeg-1.5.dll); the autoconf build system would produce the latter
- Is there any use for the executables in the tools subpackage? why not just delete them?
- are you aware that mingw-openjpeg is already in the distribution <= f18 and was dead.packaged in >=f19?
Comment 3 Sandro Mani 2013-05-09 18:50:39 EDT
Thanks for the review!

- pkgconfig: I see there are mingw{32|64}-pkg-config packages, but no packages depend on those. Some packages depend on the "regular" pkgconfig, but what does that give you?
- static libraries: from a quick glance at the buildsystem files I didn't figure out how to enable the compilation of static libraries with cmake (I'm not overly familiar with cmake I should note)
- dll: I agree, I should look at the buildsystem files and patch them... (btw I though of using cmake instead of autotools since openjpeg-2.0 is cmake only)
- tools: I'm not sure what the general rule is, many other mingw packages provide *.exe files (though usually in the main package). My idea was: keep everything that some users may find usefull for whatever reason, but put them in a separate package.
- dead package: yes I am aware
Comment 4 Sandro Mani 2013-05-09 18:54:27 EDT
(And I don't know why rpmlint is complaining about the source URLs, they work perfectly fine).
Comment 5 Thomas Sailer 2013-05-10 05:53:16 EDT
(In reply to comment #3)
> - static libraries: from a quick glance at the buildsystem files I didn't
> figure out how to enable the compilation of static libraries with cmake (I'm
> not overly familiar with cmake I should note)

Me neither, unfortunately.

> - tools: I'm not sure what the general rule is, many other mingw packages
> provide *.exe files (though usually in the main package). My idea was: keep
> everything that some users may find usefull for whatever reason, but put
> them in a separate package.

I think they used to be forbidden. There's no guidance anymore, now, that I know of. So in my opinion we should use common sense. If you can think of a use of those, then fine, package them. Right now I don't see one.
Comment 6 Erik van Pienbroek 2013-05-10 09:54:28 EDT
(In reply to comment #5)
> (In reply to comment #3)
> > - static libraries: from a quick glance at the buildsystem files I didn't
> > figure out how to enable the compilation of static libraries with cmake (I'm
> > not overly familiar with cmake I should note)
> 
> Me neither, unfortunately.

It is up to the maintainer in question to decide whether to ship static libraries or not. If the build system creates them automatically or users want it then it would make sense to ship them, otherwise just bundle the shared libraries only. It doesn't really matter

(In reply to comment #5)
> (In reply to comment #3)
> > - tools: I'm not sure what the general rule is, many other mingw packages
> > provide *.exe files (though usually in the main package). My idea was: keep
> > everything that some users may find usefull for whatever reason, but put
> > them in a separate package.
> 
> I think they used to be forbidden. There's no guidance anymore, now, that I
> know of. So in my opinion we should use common sense. If you can think of a
> use of those, then fine, package them. Right now I don't see one.

Almost all Fedora MinGW packages ship their executables in the main package. Right now we've got the following binary mingw RPMs which use the -tools suffix:

mingw32-gvnc-tools-0.5.2-1.fc19.noarch
mingw32-qt-tools-4.8.4-3.fc20.noarch
mingw64-gvnc-tools-0.5.2-1.fc19.noarch
mingw64-qt-tools-4.8.4-3.fc20.noarch

So, for consistency with the majority of the mingw packages I would recommend to bundle executables in the main package. However, I'm open to other suggestions as well. Perhaps it would make sense to bring up this subject to the mailing list so we can come up with a more generic packaging guideline on what to do with shipping executables.
Comment 7 greg.hellings 2013-05-10 10:04:18 EDT
Without some significant manual workarounds I don't believe it's possible to build both static and shared libraries from a single CMake call. The Debian packager for one library I keep the CMake files for asked for that funcitonality and it took some very significant gymnastics as I had to create separate build targets (e.g. mylib and mylib-static) and then specifically alter the build name of mylib-static so it would output mylib.a. And this still runs into major problems building with MSVC as there the static mylib.lib and the export library mylib.lib will collide (as opposed to our MinGW .a and .dll.a).

So, likely, you'll need to invoke configure and install twice if you want to build both dynamic and static. When I just glanced through the openJPEG code I didn't see the necessary support for building both static and dynamic in a single call. The differences in the two calls would be minimal. One would include

-DBUILD_SHARED_LIBS:BOOL=ON

and the other

-DBUILD_SHARED_LIBS:BOOL=OFF

Otherwise, they are probably going to be identical invocations of cmake and make.
Comment 8 Sandro Mani 2013-05-10 10:08:43 EDT
Spec URL: http://smani.fedorapeople.org/mingw-openjpeg.spec
SRPM URL: http://smani.fedorapeople.org/mingw-openjpeg-1.5.1-2.fc20.src.rpm

* Fri May 10 2013 Sandro Mani <manisandro@gmail.com> - 1.5.1-2
- Use versioned BuildRequires for mingw32/64-filesystem
- Remove unused mingw_build_win32/64 macros
- Use autotools instead of cmake

- As far as I can tell, cmake simply does not support versioned dlls on windows. So I switched back to autotools for the time being

- Tools: I've removed them (though i.e. mingw-libwebp provides the decode/encode exes in  the package) - I will start a discussion on the mingw-list.
Comment 9 Thomas Sailer 2013-05-11 03:47:15 EDT
New scratch build http://koji.fedoraproject.org/koji/taskinfo?taskID=5366128

$ rpmlint ming*.rpm
mingw32-openjpeg-debuginfo.noarch: E: debuginfo-without-sources
mingw32-openjpeg-static.noarch: W: no-documentation
mingw64-openjpeg-debuginfo.noarch: E: debuginfo-without-sources
mingw64-openjpeg-static.noarch: W: no-documentation
mingw-openjpeg.src: W: invalid-url Source0: http://openjpeg.googlecode.com/files/openjpeg-1.5.1.tar.gz HTTP Error 404: Not Found
7 packages and 0 specfiles checked; 2 errors, 3 warnings.

Warnings and errors can be ignored, see above.

APPROVED by sailer.
Comment 10 Sandro Mani 2013-05-11 05:20:54 EDT
New Package SCM Request
=======================
Package Name: mingw-openjpeg
Short Description: MinGW Windows OpenJPEG library
Owners: smani
Branches: f19
InitialCC:
Comment 11 Thomas Sailer 2013-05-11 18:45:06 EDT
Sandro, would you mind take over f18 and then close https://bugzilla.redhat.com/show_bug.cgi?id=928749 as well?
Comment 12 Sandro Mani 2013-05-11 18:48:41 EDT
Not at all - I think the procedure is that I wait for the SCM import to be completed, and then I have to file a ticket to rel-eng to unblock it for f18.
Comment 13 Gwyn Ciesla 2013-05-12 12:14:22 EDT
Unretired, please take ownership in pkgdb.
Comment 14 Sandro Mani 2013-05-12 13:02:41 EDT
Thomas, if you want me to take over f18, could you release ownership in pkgdb?
Comment 15 Thomas Sailer 2013-05-12 13:20:20 EDT
(In reply to comment #14)
> Thomas, if you want me to take over f18, could you release ownership in
> pkgdb?

Done.
Comment 16 Fedora Update System 2013-05-25 16:43:50 EDT
mingw-openjpeg-1.5.1-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/mingw-openjpeg-1.5.1-3.fc18
Comment 17 Fedora Update System 2013-05-25 16:49:15 EDT
mingw-openjpeg-1.5.1-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/mingw-openjpeg-1.5.1-3.fc19
Comment 18 Fedora Update System 2013-05-26 13:00:59 EDT
mingw-openjpeg-1.5.1-3.fc19 has been pushed to the Fedora 19 testing repository.
Comment 19 Fedora Update System 2013-06-04 17:03:20 EDT
mingw-openjpeg-1.5.1-3.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2013-06-04 23:18:09 EDT
mingw-openjpeg-1.5.1-3.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.